Package: modelDown
Title: Make Static HTML Website for Predictive Models
Version: 1.1
Authors@R: c(person("Przemysław", "Biecek", email = "przemyslaw.biecek@gmail.com", role = c("aut")), 
    person("Magda", "Tatarynowicz", email = "magda.tatarynowicz@gmail.com", role = c("aut")), 
    person("Kamil", "Romaszko", email = "kamil.romaszko@gmail.com", role = c("aut", "cre")), 
    person("Mateusz", "Urbański", email = "matiszak@gmail.com", role = c("aut")))
Description: Website generator with HTML summaries for predictive models.
    This package uses 'DALEX' explainers to describe global model behavior. 
    We can see how well models behave (tabs: Model Performance, Auditor),
    how much each variable contributes to predictions (tabs: Variable Response) 
    and which variables are the most important for a given model (tabs: Variable Importance).
    We can also compare Concept Drift for pairs of models (tabs: Drifter).
    Additionally, data available on the website can be easily recreated in current R session.
    Work on this package was financially supported by the NCN Opus grant 2017/27/B/ST6/01307 
    at Warsaw University of Technology, Faculty of Mathematics and Information Science.
Depends: R (>= 3.4.0)
License: Apache License 2.0
Encoding: UTF-8
LazyData: true
Imports: DALEX (>= 1.0), auditor (>= 0.3.0), ggplot2 (>= 3.1.0),
        whisker (>= 0.3-2), DT (>= 0.4), kableExtra (>= 0.9.0), psych
        (>= 1.8.4), archivist (>= 2.1.0), svglite (>= 1.2.1), devtools
        (>= 2.0.1), breakDown (>= 0.1.6), drifter (>= 0.2.1)
Suggests: ranger, testthat, useful
RoxygenNote: 7.1.0
URL: https://github.com/ModelOriented/modelDown
BugReports: https://github.com/ModelOriented/modelDown/issues
NeedsCompilation: no
Packaged: 2020-04-11 16:08:24 UTC; kromash
Author: Przemysław Biecek [aut],
  Magda Tatarynowicz [aut],
  Kamil Romaszko [aut, cre],
  Mateusz Urbański [aut]
Maintainer: Kamil Romaszko <kamil.romaszko@gmail.com>
Repository: CRAN
Date/Publication: 2020-04-15 00:30:03 UTC
Built: R 4.6.0; ; 2026-04-29 22:07:42 UTC; unix

library("DALEX")
library(drifter)

HELP_LINK <- 'https://modeloriented.github.io/drifter/'
DOCS_LINK <- 'https://modeloriented.github.io/drifter/reference/check_drift.html'

renderModelDriftTables <- function(data_set, factor_columns){
  factor_data <- vector()
  factor_data <- NULL

  if(length(factor_columns) > 0) {
    for(i in 1:length(factor_columns)){
      column_number <- factor_columns[[i]]
      column_name <- names(factor_columns)[i]
      temp_table <- kable_styling(kable(table(data_set[, column_number]), col.names = c(column_name, "Frequency")), bootstrap_options = c("responsive", "bordered", "hover"),full_width = FALSE)
      factor_data <- paste(factor_data, temp_table, sep="<br>")
    }
  }

  return(factor_data)
}

renderTable <- function(data_table) {
  return(kable_styling(kable(data_table), bootstrap_options = c("responsive", "bordered", "hover"), full_width = FALSE))
}

renderDrifterSection <- function(section_name, data_table) {
  section_header <- paste0("<h3 class='section-label'>", section_name, "</h3>")
  section_data <- renderTable(data_table)
  return(paste0("<div class='column'>", section_header, section_data, "</div>"))
}

generator <- function(explainer_pairs, options, img_folder) {

  drifter_data <- ""
  for(pair in explainer_pairs) {
    old_explainer <- pair[[1]]
    new_explainer <- pair[[2]]
    drifter_data <- paste0(drifter_data, "<div class='row'>", "<h3 class='model-label'>", old_explainer$label, "</h3>")
    drift <- check_drift(old_explainer$model, new_explainer$model,
                         old_explainer$data, new_explainer$data,
                         old_explainer$y, new_explainer$y,
                         predict_function = old_explainer$predict_function)

    archivist_link <- save_to_repository(drift, options)

    model_drift <- renderDrifterSection("Model Drift", drift$model_drift)
    covariate_drift <- renderDrifterSection("Covariate Drift", data.frame(Variable = drift$covariate_drift$variables , Drift = drift$covariate_drift$drift))
    residual_drift <- renderDrifterSection("Residual Drift", drift$residual_drift)
    help_section <- paste0("<help-panel help-url='", HELP_LINK, "' docs-url='", DOCS_LINK, "'></help-panel>")
    archivist_section <- paste0("<div class='archivist-code'><p>Get this object: <code>", archivist_link, "</code></p></div>")
    drifter_data <- paste0(drifter_data, model_drift, covariate_drift, residual_drift, help_section, "</div>", archivist_section)
  }

  list(
    display_name='Drifter',
    name='drifter',
    data=list(drifter_data = drifter_data)
  )
}

library("DALEX")
library(ggplot2)

HELP_LINK <- "https://pbiecek.github.io/ema/partialDependenceProfiles.html"
DOCS_LINK <- "https://modeloriented.github.io/DALEX/reference/model_profile.html"

save_plot_image <- function(file_name, models, settings){
  pl <- do.call(plot, models) + theme(text = element_text(size=settings$font_size))
  ggsave(file_name, pl, settings$device)
}

make_variable_plot <- function(variable_name, types, models, img_folder, options) {
  plot_settings <- getPlotSettings(options, "vr")
  img_filename <- paste('variable_response_', variable_name, '_', paste(types, collapse=''), '.', plot_settings$device, sep='')

  img_path <- file.path(img_folder, img_filename)

  file.create(img_path)
  save_plot_image(img_path, models, plot_settings)

  return(img_filename)
}

make_variable_plot_model <- function(variable_name, explainers, img_folder, options) {

  types <- options[["vr.type"]]
  if(is.null(types)) {
    types <- "partial"
  }

  models_per_type <- lapply(types, function(type) {
    lapply(explainers, function(explainer) { model_profile(explainer, variable_name, type=type)$agr_profiles })
  })

  models <- do.call(c, models_per_type)

  plot_filename <- make_variable_plot(variable_name, types, models, img_folder, options)

  link <- save_to_repository(models, options)

  list(
    variable_name=variable_name,
    img_filename=plot_filename,
    archivist_link = link
  )
}

sort_by_importance <- function(explainers, variables) {
  importance <- variable_importance(explainers[[1]])
  # only first permutation (from DALEX 1.0)
  importance <- importance[importance$permutation == 0,]
  variable_dropouts <- importance$dropout_loss[
    sapply(variables, function(var_name) {
      index <- which(importance$variable == var_name)
    })]
  variables_order <- order(variable_dropouts, decreasing = TRUE)
  sorted_variables <- variables[variables_order]
  return(sorted_variables)
}

generator <- function(explainers, options, img_folder, sort_by_importance = TRUE) {

  variables <- options[["vr.vars"]]
  if(is.null(variables)) {
    variables <- colnames(explainers[[1]]$data)
  }
  # how to sort variables?
  if (sort_by_importance) {
    variables <- sort_by_importance(explainers, variables)
  } else {
    variables <- sort(variables)
  }

  variable_models <- lapply(variables, make_variable_plot_model, explainers, img_folder, options)

  list(
    display_name='Variable Response',
    name='variable_response',
    data=list(
      variables=variable_models,
      HELP_LINK = HELP_LINK,
      DOCS_LINK = DOCS_LINK
    )
  )
}

library("DALEX")
library(ggplot2)

HELP_LINK <- "https://pbiecek.github.io/ema/modelPerformance.html"
DOCS_LINK <- "https://modeloriented.github.io/DALEX/reference/model_performance.html"

save_plot_image <- function(file_name, models, height, img_folder, settings){

  path <- file.path(img_folder, file_name)
  file.create(path)

  plot_obj <- do.call(plot, models) + theme(text = element_text(size=settings$font_size))
  ggsave(path, plot_obj, settings$device)
}

make_model_performance_plot_model <- function(explainers, img_folder, options) {
  plot_settings <- getPlotSettings(options, "mp")

  img_filename <- paste('model_performance', plot_settings$device, sep = '.')
  img_box_filename <- paste('model_performance_box', plot_settings$device, sep = '.')

  models <- lapply(explainers, function(explainer) {
    model_performance(explainer)
  })

  save_plot_image(img_filename, models, 5, img_folder, plot_settings)
  link_mp <- save_to_repository(models, options)

  models$geom <- "boxplot"
  save_plot_image(img_box_filename, models, 4, img_folder, plot_settings)
  link_mp_box <- save_to_repository(models, options)

  list(img_filename = img_filename,
       img_box_filename = img_box_filename,
       archivist_link_mp1 = link_mp,
       archivist_link_mp2 = link_mp_box)
}

generator <- function(explainers, options, img_folder) {

  img_filename <- make_model_performance_plot_model(explainers, img_folder, options)

  list(
    display_name='Model Performance',
    name='model_performance',
    data=list(
      img_filename_mp1 = img_filename$img_filename,
      img_filename_mp2 = img_filename$img_box_filename,
      HELP_LINK = HELP_LINK,
      DOCS_LINK = DOCS_LINK,
      archivist_link_mp1 = img_filename$archivist_link_mp1,
      archivist_link_mp2 = img_filename$archivist_link_mp2
    )
  )
}

library("DALEX")
library(ggplot2)

ROC_HELP_LINK <- "https://modeloriented.github.io/auditor/articles/model_evaluation_audit.html#receiver-operating-characteristic-roc"
ROC_DOCS_LINK <- "https://modeloriented.github.io/auditor/reference/plotROC.html"
# LIFT
LIFT_HELP_LINK <- "https://modeloriented.github.io/auditor/articles/model_evaluation_audit.html#lift-chart"
LIFT_DOCS_LINK <- "https://modeloriented.github.io/auditor/reference/plotLIFT.html"
#ACF
ACF_HELP_LINK <- "https://modeloriented.github.io/auditor/articles/model_residuals_audit.html#plotacf---autocorrelation-function-of-residuals"
ACF_DOCS_LINK <- "https://modeloriented.github.io/auditor/reference/plotACF.html"
# RANKING
RANKING_HELP_LINK <- "https://modeloriented.github.io/auditor/articles/model_performance_audit.html#model-ranking-radar-plot"
RANKING_DOCS_LINK <- "https://modeloriented.github.io/auditor/reference/plotModelRanking.html"
# RESIDUALS
RESIDUALS_HELP_LINK <- "https://modeloriented.github.io/auditor/articles/model_residuals_audit.html#plotresidual---plot-residuals-vs-observed-fitted-or-variable-values"
RESIDUALS_DOCS_LINK <- "https://modeloriented.github.io/auditor/reference/plotResidual.html"
# REC
REC_HELP_LINK <- "https://modeloriented.github.io/auditor/articles/model_residuals_audit.html#plotrec---regression-error-characteristic-rec-curve"
REC_DOCS_LINK <- "https://modeloriented.github.io/auditor/reference/plotREC.html"
# RROC
RROC_HELP_LINK <- "https://modeloriented.github.io/auditor/articles/model_residuals_audit.html#plotrroc---regression-receiver-operating-characteristic-rroc"
RROC_DOCS_LINK <- "https://modeloriented.github.io/auditor/reference/plotRROC.html"
# SCALE
SCALE_HELP_LINK <- "https://modeloriented.github.io/auditor/articles/model_residuals_audit.html#plotscalelocation---scale-location-plot"
SCALE_DOCS_LINK <- "https://modeloriented.github.io/auditor/reference/plotScaleLocation.html"


save_plot_image <- function(file_name, models, type, settings){
  pl <- do.call(plot, c(models, type = type))
  ggsave(file_name, pl, settings$device)
}

make_audit_plot_model <- function(explainers, img_folder, y, options) {

  models <- lapply(explainers, function(explainer) {
    explainer
  })

  plot_settings <- getPlotSettings(options, "a")
  extension <- plot_settings$device

  audit_plots <- list(c(paste("acf", extension, sep = '.'), "ACF"),
                      c(paste("rroc", extension, sep = '.'), "RROC"),
                      c(paste("scale_location", extension, sep = '.'), "ScaleLocation"),
                      c(paste("residuals", extension, sep = '.'), "Residual"),
                      c(paste("ranking", extension, sep = '.'), "ModelRanking"),
                      c(paste("rec", extension, sep = '.'), "REC"))
  # LIFT and ROC only for binary classification
  if (class(y) == "numeric" && length(levels(as.factor(y))) == 2) {
    audit_plots <- append(audit_plots, list(c(paste("roc", extension, sep = '.'), "ROC")))
    audit_plots <- append(audit_plots, list(c(paste("lift", extension, sep = '.'), "LIFT")))
  } else if (class(y) == "factor") {
    warning("ROC and LIFT charts are supported only for binary classification.")
  }
  result <- list()
  for(audit_plot in audit_plots) {
    img_filename <- audit_plot[1]
    img_path <- file.path(img_folder, img_filename)

    file.create(img_path)

    save_plot_image(img_path, models, audit_plot[2], plot_settings)
    result[audit_plot[2]] <- img_filename
  }

  result$link <- save_to_repository(models, options)

  return(result)
}


generator <- function(explainers, options, img_folder) {

    y = explainers[[1]]$y
    audit_img_filename <-
      make_audit_plot_model(explainers, img_folder, y, options)

    data <- list(
      # ROC
      roc_img_filename = audit_img_filename$ROC,
      ROC_HELP_LINK = ROC_HELP_LINK,
      ROC_DOCS_LINK = ROC_DOCS_LINK,
      # LIFT
      lift_img_filename = audit_img_filename$LIFT,
      LIFT_HELP_LINK = LIFT_HELP_LINK,
      LIFT_DOCS_LINK = LIFT_DOCS_LINK,
      #ACF
      acf_img_filename = audit_img_filename$ACF,
      ACF_HELP_LINK = ACF_HELP_LINK,
      ACF_DOCS_LINK = ACF_DOCS_LINK,
      # RANKING
      ranking_img_filename = audit_img_filename$ModelRanking,
      RANKING_HELP_LINK = RANKING_HELP_LINK,
      RANKING_DOCS_LINK = RANKING_DOCS_LINK,
      # RESIDUALS
      residuals_img_filename = audit_img_filename$Residual,
      RESIDUALS_HELP_LINK = RESIDUALS_HELP_LINK,
      RESIDUALS_DOCS_LINK = RESIDUALS_DOCS_LINK,
      # REC
      rec_img_filename = audit_img_filename$REC,
      REC_HELP_LINK = REC_HELP_LINK,
      REC_DOCS_LINK = REC_DOCS_LINK,
      # RROC
      rroc_img_filename = audit_img_filename$RROC,
      RROC_HELP_LINK = RROC_HELP_LINK,
      RROC_DOCS_LINK = RROC_DOCS_LINK,
      # SCALE
      scale_location_img_filename = audit_img_filename$ScaleLocation,
      SCALE_HELP_LINK = SCALE_HELP_LINK,
      SCALE_DOCS_LINK = SCALE_DOCS_LINK,
      archivist_link=audit_img_filename$link
    )

  list(
    display_name='Auditor',
    name='auditor',
    data=data
  )
}

library(DALEX)
library(ggplot2)
library(kableExtra)

HELP_LINK <- "https://pbiecek.github.io/ema/featureImportance.html"
DOCS_LINK <- "https://modeloriented.github.io/DALEX/reference/variable_importance.html"

save_plot_image <- function(file_name, models, settings){
  pl <- do.call(plot, models) + theme(text = element_text(size=settings$font_size))
  ggsave(file_name, pl, settings$device)
}

make_variable_importance_table <- function(explainers) {
  importance_table <- vector()
  importance_table <- NULL

  importance_table_list <- list()
  for (explainer_id in seq_along(explainers)) {
    explainer <- explainers[[explainer_id]]
    model <- variable_importance(explainer, type = "raw")
    # only first permutation (from DALEX 1.0)
    model <- model[model$permutation == 0,]
    importance_table_list[[explainer_id]] <- model[,c(1,3)]
  }
  importance_table <- do.call(rbind, importance_table_list)

  html <- kable_styling(kable(importance_table, row.names = FALSE),
                        bootstrap_options = c("responsive", "hover"),
                        full_width = FALSE)
  i <- 1
  for(explainer_id in seq_along(explainers)){
    explainer <- explainers[[explainer_id]]
    label <- explainer$label
    html <- group_rows(html, label, i, i + nrow(importance_table_list[[explainer_id]]) - 1,
                       hline_before = TRUE, hline_after = TRUE)
    i <- i + nrow(importance_table_list[[explainer_id]])
  }

  html
}

create_plot_image <- function(models, img_folder, options){
  plot_settings <- getPlotSettings(options, "vi")

  img_filename <- paste('variable_importance', plot_settings$device, sep='.')
  img_path <- file.path(img_folder, img_filename)

  file.create(img_path)
  save_plot_image(img_path, models, plot_settings)

  img_filename
}

generate_models <- function(explainers){
  models <- lapply(explainers, function(explainer) {
    model <- variable_importance(explainer, type="raw")
    # only first permutation (from DALEX 1.0)
    model[model$permutation == 0,]
  })
  models
}

generator <- function(explainers, options, img_folder) {

  variable_importance_table <- make_variable_importance_table(explainers)

  models <- generate_models(explainers)

  filename <- create_plot_image(models, img_folder, options)

  link <- save_to_repository(models, options)

  list(
    display_name='Variable Importance',
    name='variable_importance',
    data=list(
      img_filename=filename,
      dataframe=variable_importance_table,
      archivist_link = link,
      HELP_LINK = HELP_LINK,
      DOCS_LINK = DOCS_LINK
    )
  )
}
